/// Problem  : G (School ACM 2006)
/// Solution : Anton S. Zhuplev

{$APPTYPE CONSOLE}

uses SysUtils;

var i, j, k, l, n, m, w, p, aw, c: integer;
    posit: array[1..200] of integer;
    name, line: array[1..200] of string;
    empty: array[1..200, 0..200] of boolean;
    sep1, sep2, border, space: string;
    f: boolean;
    fi, fo: text;

procedure GenStrings;
  begin
    sep1 := '#'; space := '';
    for i := 1 to m-1 do
      begin
        for j := 1 to w do
          sep1 := sep1 + '-';
        sep1 := sep1 + '+';
      end;
    for j := 1 to w do
      begin
        sep1 := sep1 + '-';
        space := space + ' '
      end;
    sep1 := sep1 + '#';
    sep2 := '#'; border := '#';
    for i := 1 to aw do
      begin
        sep2 := sep2 + '=';
        border := border + '#'
      end;
    sep2 := sep2 + '#';
    border := border + '#';
  end;

procedure WriteBlock(var s: string; var w: integer);
  var i: integer;
  begin
    for i := 1 to (w-length(s)) div 2 do
      write(fo, ' ');
    write(fo, s);
    for i := 1 to w - length(s) - (w-length(s)) div 2 do
      write(fo, ' ');
  end;

begin
  w := 0; l := 0; f := false;
  FillChar(empty, SizeOf(empty), true);
  AssignFile(fi, 'input.txt');
  AssignFile(fo, 'output.txt');
  reset(fi);
  rewrite(fo);
  readln(fi, n, m);
  for i := 1 to n do
    begin
      readln(fi, name[i], posit[i]);
      p := (posit[i]+m-1) div m;
      empty[p, 0] := false; empty[p, posit[i]-(p-1)*m] := false;
      if length(name[i]) + 2 > w then w := length(name[i]) + 2;
      line[p] := ' ' + inttostr(p) + ' starting line ';
      if length(line[p]) > l then l := length(line[p]);
    end;
  while l > m*w + (m-1) do
    inc(w);
  aw := m*w + (m-1);
  GenStrings;
  writeln(fo, border);
  k := 1;
  for i := 1 to 100 div m + 1  do
    begin
      if empty[i][0] then continue;
      if f then writeln(fo, sep2);
      write(fo, '#'); WriteBlock(line[i], aw); writeln(fo, '#');
      writeln(fo, sep1);
      for j := 1 to m do
        begin
          write(fo, '#');
          if empty[i, j] then
            begin
              for l := 1 to m-1 do
                write(fo, space, '|');
              write(fo, space);
            end
          else
            begin
              for l := 1 to j-1 do
                write(fo, space, '|');
              WriteBlock(name[k], w);
              if j <> m then write(fo, '|');
              for l := j to m-2 do
                write(fo, space, '|');
              if j <> m then write(fo, space);
              inc(k); f := true;
            end;
          writeln(fo, '#');
        end;
    end;
  write(fo, border);
  CloseFile(fi);
  CloseFile(fo);
end.